
% ------------------------------------------------------------------------
% DEMO3P_1
% Demo program of ROBOT toolbox
% 3P type robot, default view: robot's arms are aproximated by lines
% Panel allows to change configuration of the robot
% ------------------------------------------------------------------------

% configuration variables

d1 = 5;
d2 = 7;
d3 = 3;

% robot's definition
% base is rotated around x-axis by -pi/2 radians
% grasper is placed along z-axis of the last joint's coordinale system, 
% its length equals 3 units

r = robot([0 0 d1 0; pi/2 0 d2 -pi/2; -pi/2 2 d3 0], ['p', 'p', 'p'],...
          'RobotBase', rp2t(rotx(-pi/2),[0;0;0]),...
          'RobotGrasper', rp2t(roty(-pi/2),[0; 0; 3]),...
          'RobotGrasperSize', 0.75,...
          'RobotRange', [-3.5, 8.5; 1, 11; 0, 6],...
          'RobotLineWidth', 2,...
          'RobotColor', 'b',...
          'RobotLengthColor', 'c',...
          'CSysLabel', {'B', '1', '2', '3', 'G'},...
          'CSysAxisLabel', {'X', 'Y', 'Z'});

% global coordinate system
          
axis([-8 10 -6 12 -2 14])
csys_plot(csys(eye(4), 'CSysAxisLength', axis));

% robot (plotted in view 'line'), its coordinate systems (all visible) and panel

r = robot_plot(r, 'line');
r = robot_plot_csys(r, 1, 1, 1);
robot_panel(r)

grid on
