
% ------------------------------------------------------------------------
% DEMO3P_2
% Demo program of ROBOT toolbox
% 3P type robot, default 3D view: robot's arms are aproximated by cylinders
% Panel allows to change configuration of the robot
% ------------------------------------------------------------------------

% configuration variables

d1 = 5;
d2 = 7;
d3 = 3;

% robot's definition
% base is rotated around x-axis by -pi/2 radians
% grasper is placed along z-axis of the last joint's coordinale system, 
% its length equals 3 units

r = robot([0 0 d1 0; pi/2 0 d2 -pi/2; -pi/2 2 d3 0], ['d'; 'd'; 'p'],...
          'RobotBase', rp2t(rotx(-pi/2),[0;0;0]),... 
          'RobotGrasper', rp2t(roty(-pi/2),[0; 0; 3]),...
          'RobotGrasperSize', [0.75,1],...
          'RobotRange', [-3.5, 8.5; 1, 11; 0, 6],...
          'RobotLengthColor', 'y',...
          'RobotOffsetColor', [0,0.25,0.65],...
          'RobotGrasperColor', [0,0.5,1],...
          'RobotExColor', 'g',...
          'RobotEdgeColor', 'none',... 
          'RobotCylinderRadius', 0.5,...
          'RobotCylinderApprox', 32,...
          'RobotModel', 'rangeex',...
          'CSysAxisLength', [0 2 0 2 0 2],...
          'CSysColor', 'm',...
          'CSysLabelColor', [0.5, 0.5, 0.5]);

% global coordinate system
          
axis([-8 10 -6 12 -2 14])
csys_plot(csys(eye(4), 'CSysAxisLength', axis));

% robot (plotted in view 'surf'), its coordinate systems (base not visible) and panel

r = robot_plot(r, 'surf');
r = robot_plot_csys(r, 1, 0, 1);
robot_panel(r)

camlight
grid on
