
% ------------------------------------------------------------------------
% DEMO3PR_1
% Demo program of ROBOT toolbox
% 3PR type robot, default view: robot's arms are aproximated by lines
% Panel allows to change configuration of the robot
% ------------------------------------------------------------------------

% configuration variables

d1=5;
d2=5;
d3=3;
t4=0;

% robot's definition
% base is rotated around x-axis and z-axis by -pi/2 radians, and moved along z-axis by 5 units
% grasper is placed along z-axis of the last joint's coordinale system, its length equals 2 units

r = robot([dh(0,0,d1,0); dh(-pi/2,0,d2,pi/2); dh(-pi/2,1,d3,0); dh(0,0,1,t4)], ['p','p','p','r'],...
          'RobotBase', rp2t(rotx(-pi/2)*rotz(-pi/2),[0;0;5]),...
          'RobotGrasper', rp2t(roty(-pi/2),[0; 0; 2]),...
          'RobotGrasperSize', 0.75,...
          'RobotLineWidth', 2);


% global coordinate system
          
axis([-5 15 -5 15 -5 15])
csys_plot(csys(eye(4), 'CSysAxisLength', axis));

% robot (plotted in view 'line'), its coordinate systems (all visible) and panel

r = robot_plot(r, 'line');
r = robot_plot_csys(r, 1, 1, 1);
robot_panel(r)

grid on
