
% ------------------------------------------------------------------------
% DEMO3R_1
% Demo program of ROBOT toolbox
% Planar, 3R type robot, default view: robot's arms are aproximated by lines
% Panel allows to change configuration of the robot
% ------------------------------------------------------------------------

% configuration variables

t1 = -pi/4;
t2 =  pi/2;
t3 = -pi/4;

% robot's definition
% base is rotated around x-axis by -pi/2 radians
% grasper is parallel to the x-axis of the last joint's coordinale system, 
% its length equals 0.15 units

r = robot( [dh(0,0,0,t1); dh(0,0.4,0,t2); dh(0,0.36,0,t3)], ['r', 'r', 'r'],...
           'RobotBase', rp2t(rotx(-pi/2),[0;0;0]),...
           'RobotGrasper', [0.15; 0; -0.025],...
           'RobotGrasperSize', 0.05,...
           'RobotLineWidth', 2,...
           'CSysAxisLength', [0 0.1 0 0.1 0 0.1]);


% global coordinate system

axis([-0.5 1 -0.8 0.8 -0.5 1])
csys_plot(csys(eye(4), 'CSysAxisLength', axis));

% robot (plotted in view 'line'), its coordinate systems (all visible) and panel

r = robot_plot(r, 'line');
r = robot_plot_csys(r, 1, 1, 1);
robot_panel(r)

grid on
