
% ------------------------------------------------------------------------
% DEMOPUMA_2
% Demo program of ROBOT toolbox
% PUMA type robot, default 3D view: robot's arms are aproximated by cylinders
% Panel allows to change configuration of the robot
% ------------------------------------------------------------------------

% configuration variables

t1 =  0;
t2 = -pi/4;
t3 =  pi/4;
t4 =  0;
t5 =  pi/4;
t6 =  0;

% robot's definition

d2 = 243.5/1000; d3 = -93.4/1000; d4 = -20.3/1000; l2 = 431.8/1000; l3 = 433.1/1000;
DH = [dh(0,0,0,t1); dh(-pi/2,0,d2,t2); dh(0,l2,d3,t3); dh(pi/2,l3,d4,t4); dh(-pi/2,0,0,t5); dh(pi/2,0,0,t6);];

r = robot(DH, ['r', 'r', 'r', 'r', 'r', 'r'],...
         'RobotGrasper', rp2t(eye(3),[0.05;0;0]),...
         'RobotGrasperSize', 0.075,...
         'RobotColor', [0.25, 0.45, 0.75],...
         'RobotExColor', [0, 0.65, 1],...
         'RobotEdgeColor', 'none',...
         'RobotCylinderRadius', 0.045,...
         'RobotCylinderApprox', 32,...
         'RobotModel', 'configex',...
         'CSysAxisLength', [0 0.25 0 0.25 0 0.25]);


% global coordinate system

axis([-0.5, 1, -0.75, 0.75, -0.75, 0.75])
csys_plot(csys(eye(4), 'CSysAxisLength', axis));

% robot (plotted in view 'line'), its coordinate systems (base and grasper not visible) and panel

r = robot_plot(r, 'surf');
r = robot_plot_csys(r, 1, 0, 0);
robot_panel(r);

camlight;
grid on;
