
% ------------------------------------------------------------------------
% DEMO_BLOCKS1
% Demo program of ROBOT toolbox
% Blocks available in toolbox plotted in random position
% ------------------------------------------------------------------------

axis([-10, 10, -10, 10, -10, 10])
cs = csys(eye(4), 'CSysAxisLength', axis);
cs = csys_plot(cs);

h = text(-5,0,5,'Press any key...');
pause
delete(h);

for i=1:9
    
  par = {'BlockColor', rand(1,3), 'CSysColor', 'r'};
   
  switch ( i ) 
    case 1,  b = cone(2, 3, 16, par{:});  txt = 'cone';
    case 2,  b = cube(3, par{:});  txt = 'cube';
    case 3,  b = cuboid(3, 2, 5, par{:});  txt = 'cuboid';
    case 4,  b = cylinder(1, 3, 16, par{:});  txt = 'cylinder';
    case 5,  b = polyline([[0;0;0] [2;2;0] [0;2;2]], par{:});  txt = 'polyline';
    case 6,  b = prism([[-1; -1] [0; 1] [1; 0]], 3, par{:});  txt = 'prism';
    case 7,  b = pyramid(3, 1, 4, par{:});  txt = 'pyramid';
    case 8,  b = sphere(2, 16, par{:});  txt = 'sphere';
    case 9,  b = tetrahedron(3, par{:});  txt = 'tetrahedron';
  end      
         
  p = rand(3,1)*16-8;
  b = block_move(b, p);
  b = block_plot(b, 'mesh');
  b = block_plot_csys(b);
  h = text(p(1)+2,p(2),p(3)-2, txt);
  
  pause(1);
  
  b = block_delete(b);
  delete(h);
end

cs = csys_delete(cs);
text(-5,0,5,'End demo');
