
% ------------------------------------------------------------------------
% DEMO_BLOCKS2
% Demo program of ROBOT toolbox
% Animated block created by the combination of cube, pyramid and two cuboid
% ------------------------------------------------------------------------

axis([-3 15 -3 15 -1 15]);
cs = csys(eye(4), 'CSysAxisLength', axis);
csys_plot(cs);

b1 = cube(2);
b2 = block_move(pyramid(2,2,2),[0;0;2]);
b3 = block_move(cuboid(1,1,2), rp2t(rotx(pi/2),[0;-1;1]));
b4 = block_move(cuboid(1,1,2), rp2t(rotx(-pi/2),[0;1;1]));

b = block_merge(b1,b2,b3,b4);
b = block_plot(b);

Q = {};  i = 1;
for fi=0:0.1:2*pi 
  Q{i} = rp2t(rotx(fi),[sin(2*fi)+0.2*i;cos(fi)+0.2*i;0.15*i]); 
  i = i+1;
end

b = block_motion(b,Q,0.05);
