
% ------------------------------------------------------------------------
% DEMO_ROBOT
% Demo program of ROBOT toolbox
% Function allows to run all demo scripts
% ------------------------------------------------------------------------

function demo_robot(act);

if  ( nargin == 0 ) act='init'; end

switch ( act )
    
  case 'init'
    s = 10;
    scr = get(0,'ScreenSize'); 
    fig = figure;   
    set(fig, 'MenuBar', 'none', 'Name', 'Demo ROBOT', 'NumberTitle', 'off');
    w = 16*3.5*s+s; pos=[25,scr(4)-w-60,17*s,w];
    set(fig,'Position', pos);
    for i=1:16 p(i,:)=[s, pos(4)-i*3.5*s, 15*s, 3*s]; end
    
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(1,:),...
              'String', 'Block 1', 'CallBack', 'demo_robot(''B_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(2,:),...
              'String', 'Block 2', 'CallBack', 'demo_robot(''B_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(3,:),...
              'String', 'Coordinate system', 'CallBack', 'demo_robot(''CS'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(4,:),...
              'String', '3P line', 'CallBack', 'demo_robot(''3P_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(5,:),...
              'String', '3P default 3D', 'CallBack', 'demo_robot(''3P_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(6,:),...
              'String', '3P user 3D', 'CallBack', 'demo_robot(''3P_3'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(7,:),...
              'String', '3PR line', 'CallBack', 'demo_robot(''3PR_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(8,:),...
              'String', '3PR default 3D', 'CallBack', 'demo_robot(''3PR_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(9,:),...
              'String', '3PR user 3D', 'CallBack', 'demo_robot(''3PR_3'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(10,:),...
              'String', '3R line', 'CallBack', 'demo_robot(''3R_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(11,:),...
              'String', '3R default 3D', 'CallBack', 'demo_robot(''3R_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(12,:),...
              'String', '3R user 3D', 'CallBack', 'demo_robot(''3R_3'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(13,:),...
              'String', 'PUMA line', 'CallBack', 'demo_robot(''PUMA_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(14,:),...
              'String', 'PUMA default 3D', 'CallBack', 'demo_robot(''PUMA_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(15,:),...
              'String', 'PUMA user 3D', 'CallBack', 'demo_robot(''PUMA_3'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(16,:),...
              'String', 'Trajectory', 'CallBack', 'demo_robot(''trj'')');
    
    case 'B_1',     figure; demo_blocks1;
    case 'B_2',     figure; demo_blocks2;
    case 'CS',      figure; demo_csys;
    case '3P_1',    figure; demo3p_1;
    case '3P_2',    figure; demo3p_2;
    case '3P_3',    figure; demo3p_3;
    case '3PR_1',   figure; demo3pr_1;
    case '3PR_2',   figure; demo3pr_2;
    case '3PR_3',   figure; demo3pr_3;
    case '3R_1',    figure; demo3r_1;
    case '3R_2',    figure; demo3r_2;
    case '3R_3',    figure; demo3r_3;
    case 'PUMA_1',  figure; demoPuma_1;
    case 'PUMA_2',  figure; demoPuma_2;
    case 'PUMA_3',  figure; demoPuma_3;
    case 'trj',     figure; demo_trj;
      
end;
