
function [v] = dh(alpha, a, d, theta)

%DH creates one set of Denavit-Hartenberg parameters for one link
% 
% syntax:
% [v] = dh(alpha, a, d, theta)
%
% input:
% alpha - link twist
% a     - link length
% d     - link offset
% theta - joint angle
%
% output:
% v - vector of DH parameters
%
% example:
% p = [dh(0,0,5,0); dh(pi/2,0,5,-pi/2); dh(-pi/2,2,3,0)]
% creates a DH parameters describing 3D cartesian manipulator
%

v = [alpha, a, d, theta];
