
function [p] = arch(p1, p2, r, n, convex);

v  = p2-p1;
pc = (p1+p2)/2;
h  = sqrt(r^2-(norm(p1-p2)/2)^2);
p  = [p1 p2];

ps1 = zeros(2,1);
ps2 = zeros(2,1);
if ( abs(v(1)) > abs(v(2)) )
  a = v(2)^2/v(1)^2 + 1;
  b = -2*pc(2)*a;
  c = pc(2)^2*a-h^2;
  d = b^2-4*a*c;
  if ( d < 0 ) p=0; return; end
  ps1(2) = (-b-sqrt(d))/(2*a);   ps1(1) = -v(2)/v(1) * (ps1(2)-pc(2)) + pc(1);
  ps2(2) = (-b+sqrt(d))/(2*a);   ps2(1) = -v(2)/v(1) * (ps2(2)-pc(2)) + pc(1);
else
  a = v(1)^2/v(2)^2 + 1;
  b = -2*pc(1)*a;
  c = pc(1)^2*a-h^2;
  d = b^2-4*a*c;
  if ( d < 0 ) p=0; return; end
  ps1(1) = (-b-sqrt(d))/(2*a);   ps1(2) = -v(1)/v(2) * (ps1(1)-pc(1)) + pc(2);
  ps2(1) = (-b+sqrt(d))/(2*a);   ps2(2) = -v(1)/v(2) * (ps2(1)-pc(1)) + pc(2);
end

rot = -atan2(p2(2)-p1(2),p2(1)-p1(1));
mr  = [cos(rot), -sin(rot); sin(rot) cos(rot)];
pps1 = mr*(ps1-pc);
pps2 = mr*(ps2-pc);

alpha = asin(norm(v)/2/r);
if ( pps1(2) < 0 ) 
  if ( convex ) ps=ps1; fi1=pi/2+alpha-rot; fi2=pi/2-alpha-rot;
  else ps=ps2; fi1=-pi/2-alpha-rot; fi2=-pi/2+alpha-rot; end
else
  if ( convex ) ps=ps2; fi1=pi/2+alpha-rot; fi2=pi/2-alpha-rot;
  else ps=ps1; fi1=-pi/2-alpha-rot; fi2=-pi/2+alpha-rot; end
end

fi=fi1:((fi2-fi1)/n):fi2;
p = [ps(1)+r*cos(fi); ps(2)+r*sin(fi)];
