
function [rgb] = col2rgb(col)

if ( ~iscell(col) ) col={col}; end

for i=1:length(col)

  c = col{i};

  if ( ischar(c) )
    switch (c)
      case {'y', 'yellow'},   c=[1 1 0];
      case {'m', 'magenta'},  c=[1 0 1];
      case {'c', 'cyan'},     c=[0 1 1];
      case {'r', 'red'},      c=[1 0 0];
      case {'g', 'green'},    c=[0 1 0];
      case {'b', 'blue'},     c=[0 0 1];
      case {'w', 'white'},    c=[1 1 1];
      case {'k', 'black'},    c=[0 0 0];
      case {'none', '_null'}, rgb=c;
      otherwise, rethrow(geterr('colorName'));
    end
  elseif ( size(c,2) ~= 3 ) rethrow(geterr('colorDef')); end

  if ( length(col) > 1 ) rgb{i} = c; 
  else rgb = c; end

end
