
function [R]=dorobot(dh, joints, lst, opt)

R.ident  = 'robot';     % identyfikator obiektu

R.dh     = dh;          % parametry DH
R.n      = size(dh, 1); % liczba par kinem,atycznych
R.joints = joints;      % typy pocze ('r', 'p')

% ustawienie wartoci opcji
for i=1:size(lst,1) R=rset(R, lst{i}, getfield(opt,lst{i}), 1); end
               
R.fig.view      = 0;             % metoda uyta do narysowania robota
R.fig.handle    = [];            % uchwyty obiektw tworzcych rysunek robota

R.plain.lines = rplain(R);       % tablica odcinkw tworzacych widok schematyczny

R.def3d.blocks = rdef3d(R);      % tablica bry tworzcych domylny widok 3D

R.user3d.blocks = cell(R.n+2,1); % tablica bry tworzcych widok 3D uytkownika

R.csys.view   = zeros(1,R.n+2);  % widoczno ukadw wsprzdnych poszczeglnych czonw
R.csys.handle = [];              % uchwyty obiektw tworzcych rysunek ukadw wsprzednych

R.cblock = []; % brya chwycona przez robota
R.tblock = []; % macierz przeksztacenia ukadu bryy w ukadzie efektora
