
function err = geterr(ident, varargin)

msg = 'Niezidentyfikowany bd';

switch ( ident ) 
    
  case 'argAllowed',    msg = 'Niedozwolona warto argumentu "%s", dozwolone wartoci: %s.';
  case 'argVal',        msg = 'Nieprawidowa warto argumentu "%s", dozwolone wartoci: %s.';
  case 'argValCell',    msg = 'Nieprawidowa warto argumentu "%s", oczekiwana tablica komrkowa.';
  case 'argValMtx',     msg = 'Nieprawidowa warto argumentu "%s", oczekiwana macierz %dx%d.';
  case 'argValMtx1',    msg = 'Nieprawidowa warto argumentu "%s", oczekiwana %d-wierszowa macierz.';
  case 'argValMtx2',    msg = 'Nieprawidowa warto argumentu "%s", oczekiwana %d-kolumnowa macierz.';
  case 'argValNum',     msg = 'Nieprawidowa warto argumentu "%s", oczekiwana liczba.';
  case 'argValObj',     msg = 'Nieprawidowa warto argumentu "%s", oczekiwany obiekt %s.';
  case 'argValT',       msg = 'Nieprawidowa warto argumentu "%s", macierz przeksztacenia powinna mie wymiar 4x4.';
  case 'argValTxt',     msg = 'Nieprawidowa warto argumentu "%s", oczekiwany tekst.';
  case 'argValVect',    msg = 'Nieprawidowa warto argumentu "%s", oczekiwany %d-elementowy wektor.';
  case 'argValCVect',   msg = 'Nieprawidowa warto argumentu "%s", oczekiwany wektor kolumnowy.';
  case 'argValRVect',   msg = 'Nieprawidowa warto argumentu "%s", oczekiwany wektor wierszowy.';
  case 'argValVectTxt', msg = 'Nieprawidowa warto argumentu "%s", oczekiwany %d-elementowy wektor tekstowy.';
  
  case 'trjMethod', msg = 'Nieprawidowa nazwa metody (%s).';
  case 'trjQLen',   msg = 'Nieprawidowy rozmiar wektorw - dugoci "Q0" i "Qt" musz by rwne.';
  case 'trjVLen',   msg = 'Nieprawidowy rozmiar wektora prdkoci - dugoci "V0" i "Vt" musz by rwne dugoci wektora Q0.';
  case 'trjALen',   msg = 'Nieprawidowy rozmiar wektora przyspiesze - dugoci "A0" i "At" musz by rwne dugoci wektora Q0.';
  case 'trjAUndef', msg = 'Brak wartoci przyspiesze.';
  case 'trjAZero',  msg = 'Przyspieszenia nie mog by zerowe.';

  case 'prop',           msg = 'Oczekiwana nazwa wasnoci.';
  case 'propName',       msg = 'Nieprawidowa nazwa wasnoci: "%s".';      
  case 'propVal',        msg = 'Nieprawidowa warto wasnoci "%s", dozwolone wartoci: %s.';
  case 'propValCellTxt', msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana %d-elementowa tablica komrkowa zawierajca teksty.';
  case 'propValColor',   msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana nazwa koloru lub 3-elementowy wektor opisujcy kolor.';
  case 'propValMtx',     msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana macierz %dx%d.';
  case 'propValMtx1',    msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana %d-wierszowa macierz.';
  case 'propValMtx2',    msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana %d-kolumnowa macierz.';
  case 'propValNum',     msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana liczba.';
  case 'propValRColor',  msg = 'Nieprawidowa warto wasnoci "%s", oczekiwana definicja koloru lub 4-elementowa tablica komrkowa opisujca kolory robota.';
  case 'propValVect',    msg = 'Nieprawidowa warto wasnoci "%s", oczekiwany %d-elementowy wektor.';
  case 'propValTxt',     msg = 'Nieprawidowa warto wasnoci "%s", oczekiwany tekst.';
      
  case 'colorName',    msg = 'Nieprawidowa nazwa koloru.';
  case 'colorDef',     msg = 'Nieprawidowa definicja koloru.';
  
end

err.identifier = ['ROBOT:', ident];
err.message    = sprintf(msg, varargin{:});
