
function [blocks] = rdef3darm(R,blocks,nr)

model = R.def3d.model;
if ( strcmpi(model, 'configex') | strcmpi(model, 'rangeex')) ex=1;
else ex=0; end
radius = R.def3d.cylinderRadius;
number = R.def3d.cylinderApprox;
optlen = {'BlockColor', R.fig.color{1}, 'BlockEdgeColor', R.fig.edgeColor{1}};
optoff = {'BlockColor', R.fig.color{2}, 'BlockEdgeColor', R.fig.edgeColor{2}};
optex  = {'BlockColor', R.fig.color{4}, 'BlockEdgeColor', R.fig.edgeColor{4}};
    
if ( ex ) extlen=0; else extlen=2.5*radius; end
pz = rp2t(eye(3), [0; 0; -(extlen)/2]);

joint  = R.joints(nr);
j      = R.dh(nr, :);

if ( j(2) ~= 0 ) 
  len = j(2)+extlen;  t = rp2t(roty(pi/2),[0; 0; 0])*pz;
  blocks{nr,1}=blkmv(cylinder(radius, len, number, optlen{:}), t, 0);
else blocks{nr,1}=[]; end
    
if (( j(3) ~= 0 ) | ( joint == 'p' ) | ( joint == 'd' ))
  d = j(3);  len = 0;
  extlen  = sign(d)*extlen; 
  pz(3,4) = sign(d)*pz(3,4);
  
  switch( model )
    case {'config', 'configex' }
      len = d;  t = rp2t(eye(3),[0;0;-d]); 
      if ( joint == 'd' ) 
        if ( ex & ( nr > 1 ) & ( R.joints(nr-1) == 'p' ))  extlen=sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      elseif ( joint == 'r' )
        if ( ex & ( j(2) > 0 )) extlen=sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      end
    case { 'range', 'rangeex' }
      if ( joint == 'p' ) 
        len = R.range(nr,2)-R.range(nr,1);
        if ( len < max(abs(R.range(nr,:))) ) len=max(abs(R.range(nr,:))); end
        if ( R.range(nr,2) > 0 ) t=rp2t(eye(3),[0;0;-R.range(nr,2)]); 
        else t=eye(4); end
        if ( ex ) extlen=2*radius; t=t*rp2t(eye(3),[0;0;-radius]); end
      elseif ( joint == 'd' )
        len = R.range(nr,2)-R.range(nr,1);
        if ( len < max(abs(R.range(nr,:))) ) len=max(abs(R.range(nr,:))); end
        if ( R.range(nr,1) > 0 ) t=rp2t(eye(3),[0;0;-d]); 
        else t=rp2t(eye(3),[0;0;-(d-R.range(nr,1))]); end
        if ( ex ) 
          if ( nr == 1 ) extlen=2*radius; t=t*rp2t(eye(3),[0;0;-radius]); 
          elseif ( nr > 1 ) extlen=radius; end
        end
      elseif ( joint == 'r' )
        len = d;  t = rp2t(eye(3),[0;0;-d]); 
        if ( ex & j(2) > 0 ) extlen=sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      end
  end
  
  t=t*pz;  len=len+extlen;
  if ( len ~= 0 ) blocks{nr+1,2}=blkmv(cylinder(radius, len, number, optoff{:}), t, 0);
  else blocks{nr+1,2}=[]; end
end
  
if ( ex )
  h = 1.05*radius;
  if ( joint == 'p' ) t=rp2t(eye(3),[0;0;-(d+h)]);
  else t=rp2t(eye(3),[0;0;-(h)]); end
  blocks{nr+1,3} = blkmv(cylinder(1.25*radius, 2*h, number, optex{:}), t, 0); 
else blocks{nr+1,3}=[]; end
