
function [blocks] = rdef3dgrasper(R, blocks)

model = R.def3d.model;
if ( strcmpi(model, 'configex') | strcmpi(model, 'rangeex')) ex=1;
else ex=0; end
radius = R.def3d.cylinderRadius;
number = R.def3d.cylinderApprox;
opt    = {'BlockColor', R.fig.color{3}, 'BlockEdgeColor', R.fig.edgeColor{3}};

blocks{R.n+2,1} = [];
if ( any(R.grasper(1:3,4)) )
  p  = -R.grasper(1:3,1:3)'*R.grasper(1:3,4);
  first = 1;

  if ( abs(p(3)) > 0.0001 )     
    if ( ~first ) len=sign(p(3))*(abs(p(3))+2*radius);
    else
      if ( ex ) len=sign(p(3))*(abs(p(3))+radius);  
      else len=sign(p(3))*(abs(p(3))+2.25*radius); end;
    end
    t = rp2t(eye(3),[p(1:2);-sign(p(3))*radius]);
    blocks{R.n+2, 1} = blkmv(cylinder(radius, len, number, opt{:}), t, 0);
    first = 0;
  else blocks{R.n+2,1} = []; end

  if ( abs(p(2)) > 0.0001 ) 
    if ( ~first ) len=sign(p(2))*(abs(p(2))+2*radius);
    else
      if ( ex ) len=sign(p(2))*(abs(p(2))+radius);  
      else len=sign(p(2))*(abs(p(2))+2.25*radius); end;
    end
    t = rp2t(rotx(-pi/2), [p(1);-sign(p(2))*radius;0]);
    blocks{R.n+2, 2} = blkmv(cylinder(radius, len, number, opt{:}), t, 0);
    first = 0;
  else blocks{R.n+2,2} = []; end

  if ( abs(p(1)) > 0.0001 ) 
    if ( ~first ) len=sign(p(1))*(abs(p(1))+radius);
    else
      if ( ex ) len=sign(p(1))*(abs(p(1))); 
      else len=sign(p(1))*(abs(p(1))+1.25*radius); end
    end
    t = rp2t(roty(pi/2), [0;0;0]);
    blocks{R.n+2, 3} = blkmv(cylinder(radius, len, number, opt{:}), t, 0);
  else blocks{R.n+2,3} = []; end
end

if ( all(R.grasperSize) )
  de1 = R.grasperSize(1);  
  de2 = R.grasperSize(2)/2;
  p = [ [0; de2] [de1/4; de2] [de1; de2/2] [de1/4; de2/2] [de1/4; -de2/2] [de1; -de2/2] [de1/4;-de2] [0;-de2] ];
  blocks{R.n+2,4} = blkmv(prism(p, 2*radius, opt{:}), rp2t(eye(3),[0;0;-radius]), 0);
end;

