
function [val] = rget(R, name)

switch ( name )
      
  case 'RobotBase',        val = R.base;
  case 'RobotGrasper',     val = R.grasper;
  case 'RobotGrasperSize', val = R.grasperSize;
  case 'RobotRange',       val = R.range;

  case 'RobotLineWidth',   val = R.plain.lineWidth;
  case 'RobotColor',     
    val = R.fig.color;
    if ( all(val{1}==val{2}) & all(val{1}==val{3}) & all(val{1}==val{4}) ) val=val{1}; end
  case 'RobotLengthColor',   val = R.fig.color{1};
  case 'RobotOffsetColor',   val = R.fig.color{2};
  case 'RobotGrasperColor',  val = R.fig.color{3};
  case 'RobotExColor',       val = R.fig.color{4};
  case 'RobotEdgeColor',
    val = R.fig.edgeColor;
    if ( all(val{1}==val{2}) & all(val{1}==val{3}) & all(val{1}==val{4}) ) val=val{1}; end
  case 'RobotLengthEdgeColor',   val = R.fig.edgeColor{1};
  case 'RobotOffsetEdgeColor',   val = R.fig.edgeColor{2};
  case 'RobotGrasperEdgeColor',  val = R.fig.edgeColor{3};
  case 'RobotExEdgeColor',       val = R.fig.edgeColor{4};
      
  case 'RobotCylinderRadius', val = R.def3d.cylinderRadius;
  case 'RobotCylinderApprox', val = R.def3d.cylinderApprox;
  case 'RobotModel',          val = R.def3d.model;
      
  case 'CSysAxisLength', val = R.csys.axisLength ;
  case 'CSysColor',      val = R.csys.color;
  case 'CSysLabelColor', val = R.csys.labelColor;
  case 'CSysLabel',      val = R.csys.label;
  case 'CSysAxisLabel',  val = R.csys.axisLabel;
      
end
