
function rpnl(act, R)

fig = gcf();
ud = get(fig,'UserData');
if ( ~strcmpi(act,'init') & ( isempty(ud) | isempty(ud.R) )) return; end

switch ( act )
    
  case 'init'
      
  % ustalenie zakresw pocze jeeli nie zostay ustalone (r: -pi..pi, p: 0..10)
  for i=1:R.n
    if ( R.range(i,1) == -Inf ) 
      if ( R.joints(i) == 'r' ) R.range(i,1)=-pi; 
      else  R.range(i,1)=0; end
    end
    if ( R.range(i,2) == Inf ) 
      if ( R.joints(i) == 'r' ) R.range(i,2)=pi; 
      else  R.range(i,2)=10; end
    end

    if ( R.joints(i) == 'r' ) v=R.dh(i,4); else  v=R.dh(i,3); end
    if ( v < R.range(i,1) ) R.range(i,1)=v; end
    if ( v > R.range(i,2) ) R.range(i,2)=v; end
  end

  ud.R = R;
      
  % okno i obszar rysunku
  set(fig, 'Units', 'pixels', 'ResizeFcn', 'rpnl(''resize'')', ...
    'WindowButtonUpFcn', 'rpnl(''btn_up_fig'')');

  % kontrolki
  ss = get(fig, 'Position');
  w = 35+5+150+5+30;
  h = R.n*(20+5)+35;
  ud.pnl = uipanel('Units', 'pixels', 'Position', [1,ss(4)-h,w,h], ...
    'ButtonDownFcn', 'rpnl(''btn_down_pnl'')',...
    'DeleteFcn', 'rpnl(''delete'')');
  ud.spnl  = 1;
  ud.pnl_y = h;
  ud.pnl_pos = get(ud.pnl, 'Position');
  
  ud.btn_hide = uicontrol(ud.pnl, 'Style', 'pushbutton', 'Units', 'pixels', 'Position',[w-15 h-15 12 12], ...
    'String', 'x', 'CallBack', 'rpnl(''hide'')');

  y = h-45;
  set(ud.pnl, 'FontUnits', 'pixels');
  fs = get(ud.pnl, 'FontSize');
  set(ud.pnl, 'FontUnits', 'points');
  for i=1:R.n
    min = R.range(i,1); max = R.range(i,2); 
    if ( R.joints(i) == 'r' ) v=R.dh(i,4); else  v=R.dh(i,3); end

    if ( R.joints(i) == 'r' )
      ud.lbl(i)=uicontrol(ud.pnl, 'Style', 'text', 'Units', 'pixels', 'Position',[1 y 30 fs], ...
        'HorizontalAlignment', 'right', 'FontName', 'Symbol', 'String', sprintf('q%d:',i));
    else
      ud.lbl(i)=uicontrol(ud.pnl, 'Style', 'text', 'Units', 'pixels', 'Position',[1 y 30 fs], ...
        'HorizontalAlignment', 'right', 'String', sprintf('d%d:',i));
    end
    ud.sld(i) = uicontrol(ud.pnl, 'Style', 'slider', 'Units','pixels', 'Position',[35 y 150 20], ...
      'Min', min, 'Max', max, 'Value', v, 'SliderStep', [0.01 0.1], 'CallBack', 'rpnl(''changed'')');
    ud.val(i) = uicontrol(ud.pnl, 'Style', 'text', 'Units','pixels', 'Position',[190 y 30 fs], ...
      'HorizontalAlignment', 'left', 'String', sprintf('%4.2f',v));
    y = y-25;
  end
  set(fig,'UserData', ud);
  
  
  case 'show'
      
  fpos = get(fig, 'Position');
  if ( ud.spnl == 0 )
    for i=1:ud.R.n
      set(ud.lbl(i), 'Visible', 'on'); set(ud.sld(i), 'Visible', 'on'); set(ud.val(i), 'Visible', 'on');
    end
    set(ud.pnl, 'Position', [1,fpos(4)-ud.pnl_pos(4),ud.pnl_pos(3),ud.pnl_pos(4)]);
    set(ud.btn_hide, 'Position', [ud.pnl_pos(3)-15, ud.pnl_pos(4)-15, 12, 12], 'String', 'x', 'CallBack', 'rpnl(''hide'')');
    ud.pnl_y = ud.pnl_pos(4);
    ud.spnl = 1;
  end
  set(fig, 'UserData', ud);


  case 'hide'
      
  fpos = get(fig, 'Position');
  if ( ud.spnl == 1 )
    for i=1:ud.R.n
      set(ud.lbl(i), 'Visible', 'off'); set(ud.sld(i), 'Visible', 'off');  set(ud.val(i), 'Visible', 'off');
    end
    set(ud.pnl, 'Position', [1,fpos(4)-18,ud.pnl_pos(3),18]);
    set(ud.btn_hide, 'Position', [ud.pnl_pos(3)-15, 3, 12, 12], 'String', 'o', 'CallBack', 'rpnl(''show'')');
    ud.pnl_y = 18;
    ud.spnl = 0;
  end
  set(fig, 'UserData', ud);


  case 'close'
      
  delete(ud.pnl);


  case 'delete'

  set(fig, 'UserData', []);
      

  case 'changed'
      
  v  = zeros(ud.R.n,1);
  for i=1:ud.R.n
    v(i) = get(ud.sld(i),'Value');
    set(ud.val(i),'String',sprintf('%4.2f',v(i)));
  end
  
  hold on
  ud.R = rcfgset(ud.R, v);
  ud.R = robot_delete(ud.R);
  ud.R = rplt(ud.R, -1);
  hold off
  
  set(fig,'UserData', ud);

    
  case 'resize'
      
  ppos = get(ud.pnl, 'Position');
  fpos = get(fig, 'Position');
  ppos(2) = fpos(4)-ud.pnl_y;
  if ( ppos(1)+ppos(3) > fpos(3) ) ppos(1) = fpos(3)-ppos(3); end;
  if ( ppos(2) < 1 ) ppos(2) = 1; end;
  if ( ppos(1) < 1 ) ppos(1) = 1; end;
  if ( ppos(4) > fpos(4) ) ppos(2) = fpos(4)-ppos(4); end
  set(ud.pnl, 'Position', ppos); 
  ud.pnl_y = fpos(4)-ppos(2);
  set(fig,'UserData', ud);
  
  
  case 'btn_down_pnl'
      
  if ( ud.spnl == 0 ) return; end
  
  set(fig, 'WindowButtonMotionFcn', 'rpnl(''move_pnl'')');
  ppos = get(ud.pnl, 'Position');
  ud.cursor_pos = ppos(1:2)-get(fig, 'CurrentPoint');
  set(fig,'UserData', ud);
  

  case 'btn_up_fig'

  set(fig, 'WindowButtonMotionFcn', '');


  case 'move_pnl'

  fpos = get(fig, 'Position');
  mpos = get(fig, 'CurrentPoint');
  ppos = get(ud.pnl, 'Position');
  ppos(1:2) = ud.cursor_pos+mpos;
  if ( ppos(1) < 1 ) ppos(1) = 1; end;
  if ( ppos(2) < 1 ) ppos(2) = 1; end;
  if ( ppos(1)+ppos(3) > fpos(3) ) ppos(1) = fpos(3)-ppos(3); end;
  if ( ppos(2)+ppos(4) > fpos(4) ) ppos(2) = fpos(4)-ppos(4); end;
  set(ud.pnl, 'Position', ppos); 
  ud.pnl_y = fpos(4)-ppos(2);
  set(fig,'UserData', ud);
  
end
