
function [R]=rotx(angle)

%ROTX creates a rotation matrix around x-axis
% 
% syntax:
% [R] = rotx(angle)
%
% input:
% angle - angle of rotation
%
% output:
% R - rotation matrix
%
% example:
% r = rotx(pi/2)
% creates a rotation matrix describing a rotation around x-axis by pi/2 radians
%
% See also: ROTY, ROTZ
%

c = cos(angle);  s = sin(angle);

R = [1 0 0; 0 c -s; 0 s c];