
function [R]=roty(angle)

%ROTY creates a rotation matrix around y-axis
% 
% syntax:
% [R] = roty(angle)
%
% input:
% angle - angle of rotation
%
% output:
% R - rotation matrix
%
% example:
% r = roty(pi/2)
% creates a rotation matrix describing a rotation around y-axis by pi/2 radians
%
% See also: ROTX, ROTZ
%

c = cos(angle);  s = sin(angle);

R = [c 0 s; 0 1 0; -s 0 c];