
function [R]=rotz(angle)

%ROTZ creates a rotation matrix around z-axis
% 
% syntax:
% [R] = rotz(angle)
%
% input:
% angle - angle of rotation
%
% output:
% R - rotation matrix
%
% example:
% r = rotz(pi/2)
% creates a rotation matrix describing a rotation around z-axis by pi/2 radians
%
% See also: ROTX, ROTY
%

c = cos(angle);  s = sin(angle);

R = [c -s 0; s c 0; 0 0 1];